#include "stdafx.h"
#include "testmappin.h"
#include "testmappinDoc.h"
#include "testmappinView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CTestmappinView, CScrollView)

BEGIN_MESSAGE_MAP(CTestmappinView, CScrollView)
	//{{AFX_MSG_MAP(CTestmappinView)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CTestmappinView::CTestmappinView()
{
  m_nImageWidth = 0;    
	m_nImageHeight = 0;
}

CTestmappinView::~CTestmappinView()
{
}

BOOL CTestmappinView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CScrollView::PreCreateWindow(cs);
}

void CTestmappinView::OnDraw(CDC* pDC)
{
	CTestmappinDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

  CRect r;
	GetClientRect(&r);


  //Draw the bitmap
  CDC memDC;
	memDC.CreateCompatibleDC(pDC);
  CBitmap* pOldBitmap = memDC.SelectObject(&m_Bitmap);
	pDC->BitBlt(0, 0, m_nImageWidth, m_nImageHeight, &memDC, 0, 0, SRCCOPY);
	memDC.SelectObject(pOldBitmap);

	//Fill in the rest of the window client area with solid white
	CBrush br(GetSysColor(COLOR_WINDOW));
	FillOutsideRect(pDC, &br);
}


#ifdef _DEBUG
void CTestmappinView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CTestmappinView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CTestmappinDoc* CTestmappinView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTestmappinDoc)));
	return (CTestmappinDoc*)m_pDocument;
}
#endif //_DEBUG


int CTestmappinView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CScrollView::OnCreate(lpCreateStruct) == -1)
		return -1;

  //Load in the map bitmap
	TCHAR sPath[_MAX_PATH];
	TCHAR sDrive[_MAX_DRIVE];   
	TCHAR sDir[_MAX_DIR];
	GetModuleFileName(NULL, sPath, _MAX_PATH);
	_tsplitpath(sPath, sDrive, sDir, NULL, NULL);
  _tmakepath(sPath, sDrive, sDir, _T("LEINSTER"), _T("BMP"));

	HANDLE hBitmap = LoadImage(NULL, sPath, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_CREATEDIBSECTION | LR_DEFAULTSIZE);
	ASSERT(hBitmap != NULL);

	m_Bitmap.Attach(hBitmap);
	BITMAP bm;    
	m_Bitmap.GetObject(sizeof(bm), &bm);
  m_nImageWidth = bm.bmWidth;    
	m_nImageHeight = bm.bmHeight;



  //Create the 2 map pins 
  CPoint p(454, 132);
  VERIFY(m_Pin1.SetIcon(AfxGetResourceHandle(), IDI_MAPPIN1, TRUE));
  VERIFY(m_Pin1.Create(_T("This is where I live"), WS_VISIBLE | WS_CHILD, p, this, 0xFFFF));
  m_Pin1.SetPopupMenu(IDR_POPUP);
	m_Pin1.SetAllowDrag(FALSE);

  p = CPoint(626, 187);
  VERIFY(m_Pin2.SetIcon(AfxGetResourceHandle(), IDI_MAPPIN2, FALSE));
  VERIFY(m_Pin2.Create(_T("A draggable map pin initially in the sea"), WS_VISIBLE | WS_CHILD, p, this, 0xFFFF));
  m_Pin2.SetPopupMenu(IDR_POPUP);
	m_Pin2.SetAllowDrag(TRUE);

  p = CPoint(525, 333);
  VERIFY(m_Pin3.SetIcon(AfxGetResourceHandle(), IDI_MAPPIN3, TRUE));
  VERIFY(m_Pin3.Create(_T("A Service Station"), WS_VISIBLE | WS_CHILD, p, this, 0xFFFF));
  m_Pin3.SetPopupMenu(IDR_POPUP);
	m_Pin4.SetAllowDrag(FALSE);

  p = CPoint(407, 50);
  VERIFY(m_Pin4.SetIcon(AfxGetResourceHandle(), IDI_MAPPIN4, TRUE));
  VERIFY(m_Pin4.Create(_T("Dublin City Center"), WS_VISIBLE | WS_CHILD, p, this, 0xFFFF));
  m_Pin4.SetPopupMenu(IDR_POPUP);
	m_Pin4.SetAllowDrag(FALSE);


  p = CPoint(316, 299);
  VERIFY(m_Pin5.SetIcon(AfxGetResourceHandle(), IDI_MAPPIN5, TRUE));
  VERIFY(m_Pin5.Create(_T("A Deer Farm !!!"), WS_VISIBLE | WS_CHILD, p, this, 0xFFFF));
  m_Pin5.SetPopupMenu(IDR_POPUP);
	m_Pin5.SetAllowDrag(FALSE);

  p = CPoint(168, 449);
  VERIFY(m_Pin6.SetIcon(AfxGetResourceHandle(), IDI_MAPPIN6, TRUE));
  VERIFY(m_Pin6.Create(_T("A Golf Course"), WS_VISIBLE | WS_CHILD, p, this, 0xFFFF));
  m_Pin6.SetPopupMenu(IDR_POPUP);
	m_Pin6.SetAllowDrag(FALSE);

	return 0;
}


void CTestmappinView::OnInitialUpdate() 
{
	CScrollView::OnInitialUpdate();
	
	//Set the window to the same extent as the bitmap
  SetScrollSizes(MM_TEXT, CSize(m_nImageWidth, m_nImageHeight));
	ResizeParentToFit(FALSE);
}
